#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const lodash_1 = require("lodash");
const fs_1 = __importDefault(require("fs"));
const yargs_1 = __importDefault(require("yargs"));
function run() {
    const basePath = getBasePath();
    const baseSwagger = getBaseSwagger();
    const { swaggerComponents } = require(basePath + 'dist/Backend/app.js');
    validateBaseSwagger(baseSwagger);
    baseSwagger.paths = swaggerComponents;
    console.log(JSON.stringify(baseSwagger));
}
run();
function getBasePath() {
    const currentModuleRelativePath = lodash_1.get(require, 'main.filename');
    if (!currentModuleRelativePath)
        throw new Error('Unable to locate module path');
    const currentModuleAbsolutePath = path_1.default.dirname(currentModuleRelativePath);
    const pathComponents = currentModuleAbsolutePath.split('node_modules');
    const basePath = pathComponents.slice(0, pathComponents.length - 1).join('node_modules');
    return basePath;
}
function getBaseSwagger() {
    const args = yargs_1.default(process.argv).argv;
    const configFileName = args && args.config ? args.config : 'dsapidoc.json';
    const configFile = getBasePath() + configFileName;
    const config = JSON.parse(fs_1.default.readFileSync(configFile).toString());
    return config;
}
function validateBaseSwagger(_baseSwagger) {
}
